
package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet;

@RequestScoped
@Named(WahlbeteiligungVerlaufGebietConversationSelect.COMPONENT_NAME)
public class WahlbeteiligungVerlaufGebietConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungVerlaufGebietConversationSelect";

  @Inject
  protected transient WahlbeteiligungVerlaufGebietExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahlbeteiligungVerlaufGebietConversationStore.class)
  protected transient WahlbeteiligungVerlaufGebietConversationStore conversationStore;

  public WahlbeteiligungVerlaufGebietConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public WahlbeteiligungVerlaufGebiet getEntity() {
    return getEntityInternal();
  }

  private WahlbeteiligungVerlaufGebiet getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(WahlbeteiligungVerlaufGebiet entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(WahlbeteiligungVerlaufGebiet entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected WahlbeteiligungVerlaufGebiet attach(WahlbeteiligungVerlaufGebiet entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected WahlbeteiligungVerlaufGebiet attach( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
